import { Injectable } from "@angular/core";
import { CallDeciderService } from "./call-decider.service";
import { ArrayUtilityService } from "./array-utility.service";
import { ListHandlerService } from "./response-handler/list-handler.service";
import { ObjectUtilityService } from "./object-utility.service";
import { ObjectHandlerService } from "./response-handler/object-handler.service";
import { PouchService } from "@justbe-angular/jb-pouch";
var BizconceptService = (function () {
    function BizconceptService(arrayUtility, callDeciderService, listHandlerService, objectUtility, objectHandlerService, pouchService) {
        this.arrayUtility = arrayUtility;
        this.callDeciderService = callDeciderService;
        this.listHandlerService = listHandlerService;
        this.objectUtility = objectUtility;
        this.objectHandlerService = objectHandlerService;
        this.pouchService = pouchService;
    }
    ;
    BizconceptService.prototype.sync = function (configurations) {
        var _this = this;
        this.callDeciderService.decideBizConcept(configurations).subscribe(function (res) {
            _this.delta(configurations, res);
        }, function (err) {
            if (err === 404) {
                _this.fresh(configurations);
            }
        });
    };
    BizconceptService.prototype.delta = function (configurations, respectiveDuoDucument) {
        var _this = this;
        if (!configurations.delta.params) {
            configurations.delta.params = new Array();
        }
        configurations.delta.params.push(respectiveDuoDucument.duo);
        configurations.delta.function.apply(this, configurations.delta.params).subscribe(function (deltaRes) {
            if (_this.arrayUtility.ifArray(deltaRes.lst)) {
                if (deltaRes.lst.length > 0) {
                    _this.listHandlerService.handle(deltaRes.lst, configurations, deltaRes.cp);
                }
                else {
                    console.log("nothing found in delta call as response list is empty");
                }
            }
            else if (_this.objectUtility.ifObject(deltaRes)) {
                _this.objectHandlerService.handle(deltaRes, configurations).subscribe(function (res) {
                    _this.pouchService.upsertDocument('duos', { _id: configurations.name, duo: new Date().getTime() }).map(function (res) {
                        console.log(res);
                    }, function (err) {
                        console.log(err);
                    });
                }, function (err) {
                    throw err;
                });
            }
            else {
                console.log('nothing found in delta call');
            }
        });
    };
    BizconceptService.prototype.fresh = function (configurations) {
        var _this = this;
        configurations.fresh.function.apply(this, configurations.fresh.params).subscribe(function (freshRes) {
            if (_this.arrayUtility.ifArray(freshRes.lst)) {
                if (freshRes.lst.length > 0) {
                    _this.listHandlerService.handle(freshRes.lst, configurations, freshRes.cp);
                }
                else {
                    console.log("nothing found in delta call as response list is empty");
                }
            }
            else if (_this.objectUtility.ifObject(freshRes)) {
                _this.objectHandlerService.handle(freshRes, configurations).subscribe(function (res) {
                    _this.pouchService.upsertDocument('duos', { _id: configurations.name, duo: new Date().getTime() }).map(function (res) {
                        console.log(res);
                    }, function (err) {
                        console.log(err);
                    });
                }, function (err) {
                    throw err;
                });
            }
            else {
                console.log('nothing found in delta call');
            }
        });
    };
    BizconceptService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    BizconceptService.ctorParameters = function () { return [
        { type: ArrayUtilityService, },
        { type: CallDeciderService, },
        { type: ListHandlerService, },
        { type: ObjectUtilityService, },
        { type: ObjectHandlerService, },
        { type: PouchService, },
    ]; };
    return BizconceptService;
}());
export { BizconceptService };
//# sourceMappingURL=bizconcept.service.js.map