import { Injectable } from "@angular/core";
import { PouchService } from '@justbe-angular/jb-pouch';
import { Observable } from 'rxjs';
var CallDeciderService = (function () {
    function CallDeciderService(pouchService) {
        this.pouchService = pouchService;
    }
    CallDeciderService.prototype.decideBizConcept = function (configurations) {
        return this.pouchService.getDocument('duos', configurations.name).map(function (res) {
            return res;
        }, function (err) {
            if (err.status === 404) {
                return 404;
            }
        });
    };
    CallDeciderService.prototype.decide = function (configurations) {
        var _this = this;
        return new Observable(function (observer) {
            _this.pouchService.getDocument('duos', configurations.name).subscribe(function (res) {
                observer.next(res);
                observer.complete();
            }, function (err) {
                if (err.status === 404) {
                    observer.next(404);
                    observer.complete();
                }
            });
        });
    };
    CallDeciderService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    CallDeciderService.ctorParameters = function () { return [
        { type: PouchService, },
    ]; };
    return CallDeciderService;
}());
export { CallDeciderService };
//# sourceMappingURL=call-decider.service.js.map