import { Injectable } from "@angular/core";
import { ListHandlerService } from "./response-handler/list-handler.service";
import { ObjectHandlerService } from "./response-handler/object-handler.service";
import { ArrayUtilityService } from "./array-utility.service";
import { ObjectUtilityService } from "./object-utility.service";
import { PouchWrapperService } from "./pouch-wrapper/pouch-wrapper.service";
import { LoggerService } from "@justbe-angular/jb-pouch/services/logger.service";
var DeltaLoaderService = (function () {
    function DeltaLoaderService(listHandlerService, objectHandlerService, arrayUtility, objectUtility, pouchWrapperService, loggerService) {
        this.listHandlerService = listHandlerService;
        this.objectHandlerService = objectHandlerService;
        this.arrayUtility = arrayUtility;
        this.objectUtility = objectUtility;
        this.pouchWrapperService = pouchWrapperService;
        this.loggerService = loggerService;
    }
    DeltaLoaderService.prototype.load = function (configurations, respectiveDuoDucument) {
        var _this = this;
        if (!configurations.delta.params) {
            configurations.delta.params = new Array();
        }
        configurations.delta.params.push(respectiveDuoDucument.duo);
        // if (configurations.type === 'bizconcept') {
        //     this.pouchWrapperService.getCp(configurations.name).subscribe(cp => {
        //         configurations.delta.params.push(cp);
        //     })
        // }
        configurations.delta.function.apply(this, configurations.delta.params).subscribe(function (deltaRes) {
            if (_this.arrayUtility.ifArray(deltaRes.lst)) {
                if (deltaRes.lst.length > 0) {
                    _this.listHandlerService.handle(deltaRes.lst, configurations, deltaRes.cp);
                }
                else {
                    console.log("nothing found in delta call as response list is empty");
                }
            }
            else if (_this.objectUtility.ifObject(deltaRes)) {
                // here check if type ==='bizobject'
                // then need to handle different type of logics
                // here check if type ==='bizobject'
                // then need to handle different type of logics
                _this.objectHandlerService.handle(deltaRes, configurations).subscribe(function (res) {
                    var duo = new Date().getTime();
                    if (configurations.custom && configurations.custom.getDuo) {
                        duo = configurations.custom.getDuo(deltaRes);
                    }
                    _this.pouchWrapperService.upsertDuo(configurations.name, duo);
                }, function (err) {
                    _this.loggerService.error([err]);
                });
            }
            else {
                _this.loggerService.info(['nothing found in delta call']);
            }
        });
    };
    DeltaLoaderService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    DeltaLoaderService.ctorParameters = function () { return [
        { type: ListHandlerService, },
        { type: ObjectHandlerService, },
        { type: ArrayUtilityService, },
        { type: ObjectUtilityService, },
        { type: PouchWrapperService, },
        { type: LoggerService, },
    ]; };
    return DeltaLoaderService;
}());
export { DeltaLoaderService };
//# sourceMappingURL=delta-loader.service.js.map