import { Injectable } from "@angular/core";
import { ListHandlerService } from "./response-handler/list-handler.service";
import { ObjectHandlerService } from "./response-handler/object-handler.service";
import { ArrayUtilityService } from "./array-utility.service";
import { ObjectUtilityService } from "./object-utility.service";
import { PouchWrapperService } from "./pouch-wrapper/pouch-wrapper.service";
import { LoggerService } from "@justbe-angular/jb-pouch/services/logger.service";
var FreshLoaderService = (function () {
    function FreshLoaderService(listHandlerService, objectHandlerService, arrayUtility, objectUtility, pouchWrapperService, loggerService) {
        this.listHandlerService = listHandlerService;
        this.objectHandlerService = objectHandlerService;
        this.arrayUtility = arrayUtility;
        this.objectUtility = objectUtility;
        this.pouchWrapperService = pouchWrapperService;
        this.loggerService = loggerService;
    }
    FreshLoaderService.prototype.load = function (configurations) {
        var _this = this;
        configurations.fresh.function.apply(this, configurations.fresh.params).subscribe(function (freshRes) {
            if (_this.arrayUtility.ifArray(freshRes.lst)) {
                if (freshRes.lst.length > 0) {
                    _this.listHandlerService.handle(freshRes.lst, configurations, freshRes.cp);
                }
                else {
                    console.log("nothing found in fresh call as response list is empty");
                }
            }
            else if (_this.objectUtility.ifObject(freshRes)) {
                _this.objectHandlerService.handle(freshRes, configurations).subscribe(function (res) {
                    var duo = new Date().getTime();
                    if (configurations.custom && configurations.custom.getDuo) {
                        duo = configurations.custom.getDuo(freshRes);
                    }
                    _this.pouchWrapperService.upsertDuo(configurations.name, duo);
                }, function (err) {
                    _this.loggerService.error([err]);
                });
            }
            else {
                _this.loggerService.info(['nothing found in fresh call']);
            }
        });
    };
    ;
    FreshLoaderService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    FreshLoaderService.ctorParameters = function () { return [
        { type: ListHandlerService, },
        { type: ObjectHandlerService, },
        { type: ArrayUtilityService, },
        { type: ObjectUtilityService, },
        { type: PouchWrapperService, },
        { type: LoggerService, },
    ]; };
    return FreshLoaderService;
}());
export { FreshLoaderService };
//# sourceMappingURL=fresh-loader.service.js.map