import { Injectable } from "@angular/core";
import { PouchService } from "@justbe-angular/jb-pouch";
import { StoreService } from '@justbe-angular/jb-store';
var InitialLoaderService = (function () {
    function InitialLoaderService(pouchService, storeService) {
        this.pouchService = pouchService;
        this.storeService = storeService;
    }
    InitialLoaderService.prototype.load = function (obj) {
        var _this = this;
        if (!obj.selector) {
            obj.selector = {};
        }
        this.pouchService.queryDatabase(obj).subscribe(function (res) {
            if (res) {
                _this.storeService.updateSubstore(obj.databaseName, res);
            }
        }, function (err) {
            console.log(err);
        });
    };
    InitialLoaderService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    InitialLoaderService.ctorParameters = function () { return [
        { type: PouchService, },
        { type: StoreService, },
    ]; };
    return InitialLoaderService;
}());
export { InitialLoaderService };
//# sourceMappingURL=initial-loader.service.js.map