import { Injectable } from "@angular/core";
import { InitialLoaderService } from "./initial-loader.service";
import { CallDeciderService } from "./call-decider.service";
import { DeltaLoaderService } from "./delta-loader.service";
import { FreshLoaderService } from "./fresh-loader.service";
import { BizobjectService } from "./bizobject.service";
var ManagerService = (function () {
    function ManagerService(initialLoaderService, callDeciderService, deltaLoaderService, freshLoaderService, bizobjectService) {
        this.initialLoaderService = initialLoaderService;
        this.callDeciderService = callDeciderService;
        this.deltaLoaderService = deltaLoaderService;
        this.freshLoaderService = freshLoaderService;
        this.bizobjectService = bizobjectService;
    }
    ;
    ManagerService.prototype.manage = function (configurations) {
        var _this = this;
        if (configurations.type === 'bizobject' || (configurations.bizobject && configurations.bizobject.name)) {
            this.bizobjectService.sync(configurations);
        }
        else {
            this.initialLoaderService.load({
                databaseName: configurations.name,
                selector: configurations.selector
            });
            this.callDeciderService.decide(configurations).subscribe(function (respectiveDuoDocument) {
                if (respectiveDuoDocument._id) {
                    _this.deltaLoaderService.load(configurations, respectiveDuoDocument);
                }
                else {
                    _this.freshLoaderService.load(configurations);
                }
            });
        }
    };
    ;
    ManagerService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    ManagerService.ctorParameters = function () { return [
        { type: InitialLoaderService, },
        { type: CallDeciderService, },
        { type: DeltaLoaderService, },
        { type: FreshLoaderService, },
        { type: BizobjectService, },
    ]; };
    return ManagerService;
}());
export { ManagerService };
//# sourceMappingURL=manager.service.js.map