import { Injectable } from "@angular/core";
import { ObjectHandlerService } from "./object-handler.service";
import { PouchService } from "@justbe-angular/jb-pouch";
import { PouchWrapperService } from "../pouch-wrapper/pouch-wrapper.service";
import { LoggerService } from "@justbe-angular/jb-pouch/services/logger.service";
var ListHandlerService = (function () {
    function ListHandlerService(pouchService, objectHandler, loggerService, pouchWrapperService) {
        this.pouchService = pouchService;
        this.objectHandler = objectHandler;
        this.loggerService = loggerService;
        this.pouchWrapperService = pouchWrapperService;
    }
    ListHandlerService.prototype.handle = function (listToBehandled, configurations, cp) {
        if (cp) {
            this.saveCursorPointer(cp, configurations);
        }
        this.looper(listToBehandled, 0, configurations);
    };
    ListHandlerService.prototype.looper = function (list, count, configurations) {
        var _this = this;
        if (count < list.length) {
            this.objectHandler.handle(list[count], configurations).subscribe(function (res) {
                _this.looper(list, count + 1, configurations);
            }, function (err) {
                _this.loggerService.error([err]);
            });
        }
        else {
            this.loggerService.info(['complete list fetched, now updating delta time for list']);
            this.updateListDuo(configurations);
        }
    };
    ListHandlerService.prototype.saveCursorPointer = function (cp, configurations) {
        var _this = this;
        this.pouchService.upsertDocument('cps', { _id: configurations.name, cp: cp }).subscribe(function (res) {
            console.log('cp updated');
        }, function (err) {
            _this.loggerService.error([err]);
        });
    };
    ListHandlerService.prototype.updateListDuo = function (configurations) {
        this.pouchWrapperService.upsertDuo(configurations.name, new Date().getTime());
    };
    ListHandlerService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    ListHandlerService.ctorParameters = function () { return [
        { type: PouchService, },
        { type: ObjectHandlerService, },
        { type: LoggerService, },
        { type: PouchWrapperService, },
    ]; };
    return ListHandlerService;
}());
export { ListHandlerService };
//# sourceMappingURL=list-handler.service.js.map